Bug Hunting Session
Bug 90646 (Sidebar-Styles-Improvements) - Improving the "Style & Formatting" sidebar tab
Summary: Improving the "Style & Formatting" sidebar tab
Status: NEW
Alias: Sidebar-Styles-Improvements
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on: 90931
Blocks: Styles Sidebar-Styles
  Show dependency treegraph
 
Reported: 2015-04-16 06:59 UTC by Tomaz Vajngerl
Modified: 2019-08-30 05:42 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
Paragraph Styles in Properties (175.69 KB, image/png)
2015-04-21 00:54 UTC, Tomaz Vajngerl
Details
mockup (46.95 KB, image/png)
2015-04-23 01:55 UTC, Yousuf Philips (jay) (retired)
Details
IBM Symphony styles sidebar tab (16.49 KB, image/png)
2015-04-25 16:50 UTC, Yousuf Philips (jay) (retired)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Tomaz Vajngerl 2015-04-16 06:59:30 UTC
Style & Formatting sidebar in current state is too complex - its has functions that are used for managing of styles (for example drag&drop moving of styles, views to see "hidden" styles, user defined styles, ...). Also the styles are not context aware - all styles are always shown regardless what object is currently selected.

For this reason I propose we create a modal dialog where the use can manage all the styles (where he can also have more space to do so, instead of space limited sidebar).

For styles in sidebar I propose we move them to the front:
- paragraph and character styles in paragraph and character properties
- frame styles in image (and related object) properties
- page styles to page properties
- numbering styles - add numbering properties
Comment 1 Yousuf Philips (jay) (retired) 2015-04-20 23:35:56 UTC
(In reply to Tomaz Vajngerl from comment #0)
> Style & Formatting sidebar in current state is too complex - its has
> functions that are used for managing of styles (for example drag&drop moving
> of styles, views to see "hidden" styles, user defined styles, ...).

Totally agree with you that it to complex for the average user and is geared towards the power/advanced user. One of the biggest problems i see with it is that it doesnt list both paragraph and character styles in the same view, which does cause quite a bit of hassle (recently happened with joel). Didnt know drag & drop was possible, thanks. :D

> Also the
> styles are not context aware - all styles are always shown regardless what
> object is currently selected.

It is somewhat context aware, as the list switches from paragraph styles to frame styles when you click on an image. But then writer doesnt have shape styles which impress does.

> For this reason I propose we create a modal dialog where the use can manage
> all the styles (where he can also have more space to do so, instead of space
> limited sidebar).

Dont think that adding the functionality into a dialog will reduce the complexity of styles.

> For styles in sidebar I propose we move them to the front:
> - paragraph and character styles in paragraph and character properties

This would only be applicable to writer, as calc has cell styles and impress/draw have graphic styles. There is a bug report for it (bug 73071).

> - frame styles in image (and related object) properties

I assume if we bundle more image styles that people can choose from, then it maybe useful to have it in the image properties section.

> - page styles to page properties

I've suggested the creation of a page tab for the sidebar (bug 83830).

> - numbering styles - add numbering properties

We dont have a dedicated numbering properties section and we do have easy numbering options, so i'm not sure how often numbering styles are used.
Comment 2 Tomaz Vajngerl 2015-04-21 00:52:03 UTC
(In reply to Jay Philips from comment #1)
> Totally agree with you that it to complex for the average user and is geared
> towards the power/advanced user. 

Which is already a problem - as we should encourage average users to use styles.

> One of the biggest problems i see with it
> is that it doesnt list both paragraph and character styles in the same view,
> which does cause quite a bit of hassle (recently happened with joel). 

> Didnt know drag & drop was possible, thanks. :D
I dragged and dropped in hierarchy view by mistake many times which screwed up my styles a lot.

> It is somewhat context aware, as the list switches from paragraph styles to
> frame styles when you click on an image. But then writer doesnt have shape
> styles which impress does.

OK, it is not context aware enough. :)

It doesn't have shape styles but does have shapes. I think there is a bug about this already.

> Dont think that adding the functionality into a dialog will reduce the
> complexity of styles.

I think all the managing of the styles should go into a modal dialog, where you can rearrange and modify the styles however you like, and can't screw up the style hierarchy so easily. As for the sidebar we need to come up with an alternative, where only a relevant list of styles is shown (and stuff like drag and drop is not possible). Either that or we move them to the right places in the properties section.

> This would only be applicable to writer, as calc has cell styles and
> impress/draw have graphic styles. There is a bug report for it (bug 73071).

Sure, I just looked at writer - but in general the same applies for calc, impress and draw. 

> I assume if we bundle more image styles that people can choose from, then it
> maybe useful to have it in the image properties section.

Which would only make sense... our bundled defaults are really poor. 

> We dont have a dedicated numbering properties section and we do have easy
> numbering options, so i'm not sure how often numbering styles are used.

If there is no numbering properties section, we can add it in the sidebar at the place where other options are available (additional pop-up).
Comment 3 Tomaz Vajngerl 2015-04-21 00:54:03 UTC
Created attachment 114973 [details]
Paragraph Styles in Properties
Comment 4 Tomaz Vajngerl 2015-04-21 01:02:47 UTC
I like how iWork Pages does Paragraph Styles so with that inspiration I created a new Styles section where the current style is shown, but the idea is that you could change the style there to (pop-up). I can work on this, if you think this is a good idea.
Comment 5 Cor Nouws 2015-04-21 07:22:42 UTC
(In reply to Tomaz Vajngerl from comment #2)
> (In reply to Jay Philips from comment #1)

> > We dont have a dedicated numbering properties section and we do have easy
> > numbering options, so i'm not sure how often numbering styles are used.
> 
> If there is no numbering properties section, we can add it in the sidebar at
> the place where other options are available (additional pop-up).

There are the mentioned numbering (and list) styles.
And in the Styles dialog numbering can be linked to a style.
And there is potential interaction between linking a numbering style in the styles dialog and the behavior of outline numbering.. 
The latter makes it confusing for people coming from Word (which is sad, but the fault of Word, i.e. no reason to break down how it works in Writer).
And combining Tools > Outline numbering with numbering set in the style dialog is needed for some advanced use cases.

Just to add some notes here ;)
Comment 6 Cor Nouws 2015-04-21 07:25:01 UTC
Hi Tomaz,

Thanks for working on this, and Jay for helping!

(In reply to Tomaz Vajngerl from comment #4)
> I like how iWork Pages does Paragraph Styles so with that inspiration I
> created a new Styles section where the current style is shown, but the idea
> is that you could change the style there to (pop-up). I can work on this, if
> you think this is a good idea.

No idea how it looks..
From UX work on improving dialogs we know that there is always a little risk to loose functionality. So take care ;)

I'll add some bug reports that I know of, where people added ideas about e.g. numbering in styles.
Comment 7 Cor Nouws 2015-04-21 07:34:42 UTC
Needless to say that I would have loved to work on all details of the linked reports, but alas..
Comment 8 Yousuf Philips (jay) (retired) 2015-04-21 13:50:17 UTC
(In reply to Tomaz Vajngerl from comment #2)
> (In reply to Jay Philips from comment #1)
> > Totally agree with you that it to complex for the average user and is geared
> > towards the power/advanced user. 
> 
> Which is already a problem - as we should encourage average users to use
> styles.

We definitely should encourage them to use styles, but doubt the styles & formatting tab would be the place to do it, though simplifying the initial view of the tab would be useful. I personally like MS Word's initial view of showing a recommended list of both paragraph and character styles and the easy ability to enable and disable style previews.

http://img-aws.ehowcdn.com/default/cme/photography.prod.demandstudios.com/9d4dd6bd-c8cf-4fc4-a385-ccd1b671ae6a.png

> > It is somewhat context aware, as the list switches from paragraph styles to
> > frame styles when you click on an image. But then writer doesnt have shape
> > styles which impress does.
> 
> OK, it is not context aware enough. :)

Definitely not enough, as if you have set the paragraph style to default and the character style to emphasis, it wont think to switch to character styles.

> It doesn't have shape styles but does have shapes. I think there is a bug
> about this already.

There has never been shape styles, just like there has never been table styles, so i dont think its a bug but likely just a limitation of text documents. But we should still have an easy means of users selecting from an inbuild set of styles.

> > Dont think that adding the functionality into a dialog will reduce the
> > complexity of styles.
> 
> I think all the managing of the styles should go into a modal dialog, where
> you can rearrange and modify the styles however you like, and can't screw up
> the style hierarchy so easily.

Presently we already have a dialog to add/edit styles, so would this new styles management dialog encompass the current dialog, as i'd assume people would hate to have to jump from management dialog to style dialog to work with styles.

> As for the sidebar we need to come up with an
> alternative, where only a relevant list of styles is shown (and stuff like
> drag and drop is not possible). Either that or we move them to the right
> places in the properties section.

I think the MS Word way would be the best. It default to show a list of 'Recommended' styles, which is the same list which appears in the ribbon UI, though you can change which styles are shown.

https://wordknowhow.files.wordpress.com/2013/01/untitled.jpg

The style list is sorted 'As Recommended' but is be changed.

http://www.java2s.com/Tutorial/Microsoft-Office-Word-2007Images/Change_Styles_Pane_Options___Then_Select_Styles_You_Want_To_Show.PNG

When you mouse over the entry in the list, it shows the style info in a tooltip.

http://addbalance.com/usersguide/images/stylesFPane2010.gif

> > This would only be applicable to writer, as calc has cell styles and
> > impress/draw have graphic styles. There is a bug report for it (bug 73071).
> 
> Sure, I just looked at writer - but in general the same applies for calc,
> impress and draw. 

Not completely as writer has 2 types of styles and calc/impress/draw only have a single type of style which isnt character or paragraph, so it couldnt be put into the character or paragraph sections of the properties tab.

> > I assume if we bundle more image styles that people can choose from, then it
> > maybe useful to have it in the image properties section.
> 
> Which would only make sense... our bundled defaults are really poor. 

I see this as one of the reasons why people dont use styles in LO.

> > We dont have a dedicated numbering properties section and we do have easy
> > numbering options, so i'm not sure how often numbering styles are used.
> 
> If there is no numbering properties section, we can add it in the sidebar at
> the place where other options are available (additional pop-up).

The paragraph section has numbering properties, but its just limited to split buttons for bullets and numbering. With a dedicated numbering section, we could integrate the level management buttons from the 'Bullets and Numbering' toolbar into the section.

(In reply to Tomaz Vajngerl from comment #4)
> I like how iWork Pages does Paragraph Styles so with that inspiration I
> created a new Styles section where the current style is shown, but the idea
> is that you could change the style there to (pop-up). I can work on this, if
> you think this is a good idea.

Yes i also do like iWork's sidebar and have used it as inspiration to the many sidebar mockups i've done (attachment 109496 [details], attachment 106594 [details]). I think a styles section would be a useful step forward in writer's sidebar and it should contain drop downs for both paragraph and character styles. Hopefully this section can be used as in the future as a means of setting style sets as well. I dont think the paragraph style drop down needs to be as huge as in iWorks and when i did the this mockup (attachment 109496 [details]), i took into consideration alot of factors to end up at that height, though it could be slightly longer. The character style drop down should be similar to the height of other drop downs in the sidebar (e.g. font name).
Comment 9 Cor Nouws 2015-04-21 15:26:05 UTC
(In reply to Jay Philips from comment #8)

> We definitely should encourage them to use styles, but doubt the styles &
> formatting tab would be the place to do it, though simplifying the initial
> view of the tab would be useful. I personally like MS Word's initial view of
> showing a recommended list of both paragraph and character styles and the
> easy ability to enable and disable style previews.
> 
> http://img-aws.ehowcdn.com/default/cme/photography.prod.demandstudios.com/
> 9d4dd6bd-c8cf-4fc4-a385-ccd1b671ae6a.png

I need to come back on this. (Keep in mind that the overwhelming majority of reactions that I know, indicate that using styles in Word is messy. What I interpret as that it does not show what the structure is.)
Comment 10 Yousuf Philips (jay) (retired) 2015-04-21 20:22:35 UTC
(In reply to Cor Nouws from comment #9)
> I need to come back on this. (Keep in mind that the overwhelming majority of
> reactions that I know, indicate that using styles in Word is messy. What I
> interpret as that it does not show what the structure is.)

Not sure i fully understood what you meant hear, but i dont believe we need to completely copy them but we shouldnt ignore the way the implement a feature that we are looking to improve on.
Comment 11 Cor Nouws 2015-04-21 20:49:03 UTC
(In reply to Jay Philips from comment #10)

> Not sure i fully understood what you meant hear, but i dont believe we need
> to completely copy them but we shouldnt ignore the way the implement a
> feature that we are looking to improve on.

Yes sure (not not sure ;) )
Word offers (offered anyway) various items in the 'styles' list. Namely the styles, and the styles+combined+direct+formatting. Which makes it confusing.
And sort of promotes using all mixed. 

But the idea to have a visual presentation that at once shows both the paragraph style and the character style, looks good to me. (though I never had any trouble with it personally, after I had learned that both exist and how they can be applied).
Comment 12 Yousuf Philips (jay) (retired) 2015-04-22 23:25:49 UTC
I see that you've updated the style list Tomaz with previews, which is great but please do add a checkbox to be able to disable the previews. I'm assuming alot of advanced users wont care for the preview, like Cor. :D

I was playing with the list and noticed a bug that if you modify an entry, it wont refresh the preview.

Not sure if its useful to have style previews in frame, page, and list styles, as they all look the same in the preview. It might be useful in frame styles if its possible to show text alignment and borders. It might be useful in list styles if its possible to show the bullets.

I see that we have an 'Automatic' setting in paragraph styles, which i believe we can use to work similar to Word's 'Recommended' setting, because presently all it is a duplicate of 'Text Styles'. So it would be useful to set 'Automatic' as the default view for paragraph styles and it should contain the following.

1. Entries under 'Applied Styles', so users can modify a style they have already used.

2. Entries under 'Custom Styles', so users can edit a style they have created but that hasnt been applied yet.

3. Primary text styles like 'Default Style', 'Text Body', 'Quotations', and 'Preformatted Text'.

4. Primary Heading styles like 'Title', 'Subtitle', 'Heading 1', 'Heading 2', and 'Heading 3'.

5. Additional Heading styles when a previous Heading style is used, which means that if a user selects 'Heading 3', 'Heading 4' should show up on the list, and if a user selects 'Heading 4', 'Heading 5' should show up on the list, and so.
Comment 13 Yousuf Philips (jay) (retired) 2015-04-23 01:55:45 UTC
Created attachment 115020 [details]
mockup

(In reply to Cor Nouws from comment #11)
> But the idea to have a visual presentation that at once shows both the
> paragraph style and the character style, looks good to me. (though I never
> had any trouble with it personally, after I had learned that both exist and
> how they can be applied).

Yes i think its important to see both paragraph styles and character styles together, so less confusion happens when a user is dealing with text and they wouldnt need to jump between the paragraph style and character style tabs in order to see the full picture. So i think we should combine the two text styles into a single tab by having two list controls in it. It would also be useful to displays whatever direct formatting has been applied and the ability to clear it.
Comment 14 Tomaz Vajngerl 2015-04-23 04:49:01 UTC
(In reply to Jay Philips from comment #12)
> I see that you've updated the style list Tomaz with previews, which is great
> but please do add a checkbox to be able to disable the previews. I'm
> assuming alot of advanced users wont care for the preview, like Cor. :D

Yes, this is planned. The advanced users have shortcut keys assigned to styles so they don't use "Styles & Formatting" at all (and the sidebar in general).. :)

> I was playing with the list and noticed a bug that if you modify an entry,
> it wont refresh the preview.

I'm aware of that, previously a refresh was not needed, but it is now so I just need to find the right place to do a refresh. :)

> Not sure if its useful to have style previews in frame, page, and list
> styles, as they all look the same in the preview. It might be useful in
> frame styles if its possible to show text alignment and borders. It might be
> useful in list styles if its possible to show the bullets.

I'm aware of that as well, alignment and other text related are planned. Anything can be added, it is just a matter of reading the style and rendering it. :)

> I see that we have an 'Automatic' setting in paragraph styles, which i
> believe we can use to work similar to Word's 'Recommended' setting, because
> presently all it is a duplicate of 'Text Styles'. So it would be useful to
> set 'Automatic' as the default view for paragraph styles and it should
> contain the following.
> 
> 1. Entries under 'Applied Styles', so users can modify a style they have
> already used.
> 
> 2. Entries under 'Custom Styles', so users can edit a style they have
> created but that hasnt been applied yet.
> 
> 3. Primary text styles like 'Default Style', 'Text Body', 'Quotations', and
> 'Preformatted Text'.
> 
> 4. Primary Heading styles like 'Title', 'Subtitle', 'Heading 1', 'Heading
> 2', and 'Heading 3'.
> 
> 5. Additional Heading styles when a previous Heading style is used, which
> means that if a user selects 'Heading 3', 'Heading 4' should show up on the
> list, and if a user selects 'Heading 4', 'Heading 5' should show up on the
> list, and so.

I'll try to tune this when I have the time.
Comment 15 Yousuf Philips (jay) (retired) 2015-04-23 06:39:32 UTC
(In reply to Tomaz Vajngerl from comment #14)
> Yes, this is planned. The advanced users have shortcut keys assigned to
> styles so they don't use "Styles & Formatting" at all (and the sidebar in
> general).. :)

To my knowledge, style/advanced users live in 'Styles & Formatting' because though you can set styles using shortcut keys, you cant edit and management them with it. :D

> I'm aware of that, previously a refresh was not needed, but it is now so I
> just need to find the right place to do a refresh. :)

:D

> I'm aware of that as well, alignment and other text related are planned.
> Anything can be added, it is just a matter of reading the style and
> rendering it. :)

I believe rendering the non-text part of it will also be useful when this is adopted into Calc. The one place i think alignment features should be ignored is in hierarchical view. :D

> I'll try to tune this when I have the time.

Thanks. I think this same automatic list would be beneficial to replace what we currently have in the toolbar style drop down menu as well.

If you ever get into modifying the style entry context menu, there isnt an 'update style' entry in it, though its in the group button in the toolbar. There isnt also a means to duplicate a style (bug 87711).

By the way, do you happen to know the uno command for 'update style', as i was hoping to include it in the shape context menu in Impress (bug 89155).
Comment 16 Yousuf Philips (jay) (retired) 2015-04-25 16:50:22 UTC
Created attachment 115095 [details]
IBM Symphony styles sidebar tab

Was digging around in IBM Symphony and noticed their styles sidebar tab is different, so i thought it would be useful to include here. :D
Comment 17 Heiko Tietze 2015-04-27 09:53:14 UTC
Would be a perfect topic for a Friday design session.
Comment 18 David 2015-04-29 06:28:25 UTC
Combining the paragraph and character styles is the worst idea I have heard of.  That would in no way be an improvement.  When you use the number of styles that I do it would be a big mess.  Just because MS Office does can't do styles properly does not mean LibreOffice has to emulate them.

I found this thread because I just re-compiled the master and found that the Styles and Formatting panel is getting messed with.  I can understand why it might be nice to have a preview of the styles, but the entries are too large and now way to much scrolling needs to be done to find the style needed.  If this is the way it's going to be please add an option for to be able to view it the original way.

Like I said, I use styles heavily, and I have a number of complex documents where I use a lot of them.  Please do not make things harder just because you think you need to emulate the terrible Styles design of MS Office.
Comment 19 Cor Nouws 2015-05-04 08:55:30 UTC
(In reply to David from comment #18)
> Combining the paragraph and character styles is the worst idea I have heard
> of.  That would in no way be an improvement.  When you use the number of
> styles that I do it would be a big mess.  Just because MS Office does can't
> do styles properly does not mean LibreOffice has to emulate them.

If I must understand this that MSOffice combines the paragraph styles and character styles + whatever more in clumsy names to show it as one 'style', I fully agree with you.
Indeed that is the way that makes it hard to see and understand what is going on for users, and thus hard to use and learn.

But if the idea is (what I hope) that there is an attempt to show a list of character styles together with a list of paragraph styles, I expect that to be an improvement.

> and now way to much scrolling needs to be done to find the style needed.  If
> this is the way it's going to be please add an option for to be able to view
> it the original way.

Sounds as a fair and valid request to me.

> Like I said, I use styles heavily, and I have a number of complex documents
> where I use a lot of them.  Please do not make things harder just because
> you think you need to emulate the terrible Styles design of MS Office.

;) +1
Comment 20 David 2015-05-05 09:06:22 UTC
(In reply to Cor Nouws from comment #19)
> But if the idea is (what I hope) that there is an attempt to show a list of
> character styles together with a list of paragraph styles, I expect that to
> be an improvement.

I can see where some might like to have a separate character list and paragraph list in the same panel as shown in the mockup attachment.  But I would still ask for the possibility for the option to have it as it is now.  

The mockup proposes to have 2 smaller list boxes in the place where I like to be able to resize the list box to have more items visible.  I have some documents where I use a lot of styles, and I like to keep my scrolling to a minimum.

Then another issue would be that because bug 67230 from almost 2 years ago still isn't fixed, I must use navigator panel instead of the navigator in the sidebar.  I keep the navigator panel positioned below the sidebar. If the sidebar was done like in the mockup, then even more screen real estate would be taken up by trying to display both lists at the same time.  Fix bug 67230 and I might not complain quite as much, but I would still like the option to have a separate character style panel in the sidebar so that I can limit the scrolling needed. Make another sidebar panel which has both lists in it, if that what is wanted, but make it as an additional option, not as a replacement.
Comment 21 Bastián Díaz 2015-09-22 07:10:57 UTC
Hello, I want an idea in his analysis for Styles and Formatting sidebar. 
See Bug 94427

Intensively using the Styles and Formatting, it becomes confusing to identify which style (paragraph/character) is used by the current selection, because that is indicated by the same method of highlighted selection.
In some cases I have to select another style and return to select a paragraph to ensure that you use the right style, resulting in lost time.

An easy solution is to add an indicator showing which is the style used for the current selection. https://bugs.documentfoundation.org/attachment.cgi?id=118917

I hope this fits the planned design.

Cheers
Comment 22 Cor Nouws 2015-11-10 14:10:26 UTC
(In reply to Tomaz Vajngerl from comment #0)

> For this reason I propose we create a modal dialog where the use can manage
> all the styles (where he can also have more space to do so, instead of space
> limited sidebar).

I like that idea. (And is more or less what comes as a result from a discussion about the Navigator too)
  https://bugs.documentfoundation.org/show_bug.cgi?id=89566#c26
Comment 23 QA Administrators 2017-10-24 06:59:26 UTC Comment hidden (obsolete)
Comment 24 Cor Nouws 2017-12-30 11:22:02 UTC
maybe set to enhancement to prevent mass-pings on this bug